diff -rN -u old-darcsweb/config.py.sample new-darcsweb/config.py.sample
--- old-darcsweb/config.py.sample	2024-06-02 11:27:01.616310344 +0100
+++ new-darcsweb/config.py.sample	2024-06-02 11:27:01.620310410 +0100
@@ -84,6 +84,14 @@
 	# option.
 	#disable_annotate = True
 
+	# If you want to show the README file (in markdown format or plain text)
+	# of the project on summary and tree pages, set this to the exactly name
+	# of this file (usually 'README.md').
+	# If not set or empty, no README file will be shown (except on
+	# repositories set in their own class).
+	# If the file specified doesn't exist in a project or has a different
+	# name, no README file will be shown for that project (without errors).
+	#readme = 'README.md'
 
 
 #
@@ -130,6 +138,10 @@
 	# software in your repository.
 	#repoprojurl = 'http://example.com/projects/repo1/'
 
+	# The same as the base configuration readme but only affects this
+	# repository. Optional. If you don't specify here, the one specified in
+	# base is used.
+	#readme = 'README.md'
 
 class repo2:
 	reponame = 'repo2'
diff -rN -u old-darcsweb/darcsweb.cgi new-darcsweb/darcsweb.cgi
--- old-darcsweb/darcsweb.cgi	2024-06-02 11:27:01.620310410 +0100
+++ new-darcsweb/darcsweb.cgi	2024-06-02 11:27:01.620310410 +0100
@@ -1,4 +1,4 @@
-#!/usr/bin/env python
+#!/usr/bin/env python3
 
 """
 darcsweb - A web interface for darcs
@@ -9,19 +9,29 @@
 """
 
 import time
+
 time_begin = time.time()
+
 import sys
 import os
+import io
 import string
+import unicodedata
+import re
 import stat
 import cgi
-import cgitb; cgitb.enable()
-import urllib
+import cgitb
 import xml.sax
-from xml.sax.saxutils import escape as xml_escape
+import urllib.parse
+import xml.sax.saxutils
+
+# For typing annotations.
+from typing import List, Tuple, Iterable
+
+cgitb.enable()
 time_imports = time.time() - time_begin
 
-iso_datetime = '%Y-%m-%dT%H:%M:%SZ'
+iso_datetime = "%Y-%m-%dT%H:%M:%SZ"
 
 PATCHES_PER_PAGE = 50
 
@@ -31,305 +41,341 @@
 # before the normal path. This allows per-directory config files (desirable
 # for multiple darcsweb installations on the same machin), and avoids name
 # clashing if there's a config.py in the standard path.
-sys.path.insert(1, '/etc/darcsweb')
+sys.path.insert(1, "/etc/darcsweb")
 
 # Similarly, when hosting multiple darcsweb instrances on the same
 # server, you can just 'SetEnv DARCSWEB_CONFPATH' in the httpd config,
 # and this will have a bigger priority than the system-wide
 # configuration file.
-if 'DARCSWEB_CONFPATH' in os.environ:
-	sys.path.insert(1, os.environ['DARCSWEB_CONFPATH'])
+if "DARCSWEB_CONFPATH" in os.environ:
+    sys.path.insert(1, os.environ["DARCSWEB_CONFPATH"])
 
-# empty configuration class, we will fill it in later depending on the repo
+# Empty configuration class, we will fill it in later depending on the repo.
+# The attributes are purely for type checking. Once we have Python 3.7 as the
+# minimum supported version, we can turn these into proper annotations.
 class config:
-	pass
+    darcslogo = ""
+    darcsfav = ""
+    cssfile = ""
+    myname = ""
+    myurl = ""
+    darcspath = ""
+    summary = ""
+    footer = ""
+    cachedir = ""
+    searchlimit = 0
+    logtimes = ""
+    url_links = []  # type: Iterable[Tuple[str, str]]
+    author_links = ""
+    disable_annotate = False
+    reponame = ""
+
 
 # list of run_darcs() invocations, for performance measures
-darcs_runs = []
+darcs_runs = []  # type: List[Tuple[str]]
 
 # exception handling
 def exc_handle(t, v, tb):
-	try:
-		cache.cancel()
-	except:
-		pass
-	cgitb.handler((t, v, tb))
+    try:
+        cache.cancel()
+    except:
+        pass
+    cgitb.handler((t, v, tb))
+
+
 sys.excepthook = exc_handle
 
 #
 # utility functions
 #
 
+
 def filter_num(s):
-	l = [c for c in s if c in string.digits]
-	return ''.join(l)
+    l = [c for c in s if c in string.digits]
+    return "".join(l)
+
+
+allowed_in_action = string.ascii_letters + string.digits + "_"
 
 
-allowed_in_action = string.ascii_letters + string.digits + '_'
 def filter_act(s):
-	l = [c for c in s if c in allowed_in_action]
-	return ''.join(l)
+    l = [c for c in s if c in allowed_in_action]
+    return "".join(l)
+
+
+allowed_in_hash = string.ascii_letters + string.digits + "-."
 
 
-allowed_in_hash = string.ascii_letters + string.digits + '-.'
 def filter_hash(s):
-	l = [c for c in s if c in allowed_in_hash]
-	return ''.join(l)
+    l = [c for c in s if c in allowed_in_hash]
+    return "".join(l)
 
 
 def filter_file(s):
-	if '..' in s or '"' in s:
-		raise Exception, 'FilterFile FAILED'
-	if s == '/':
-		return s
-
-	# remove extra "/"s
-	r = s[0]
-	last = s[0]
-	for c in s[1:]:
-		if c == last and c == '/':
-			continue
-		r += c
-		last = c
-	return r
+    if ".." in s:
+        raise Exception("Invalid file name, contains '..'")
+    if s == "/":
+        return s
+
+    # remove extra "/"s
+    r = s[0]
+    last = s[0]
+    for c in s[1:]:
+        if c == last and c == "/":
+            continue
+        r += c
+        last = c
+    return r
 
 
 def printd(*params):
-	print ' '.join(params), '<br/>'
+    print(" ".join(params), "<br/>")
+
+
+def xmlescape(s):
+    """Escape string for use inside XML."""
+    return xml.sax.saxutils.escape(s, entities={'"': "&quot;"})
 
 
-# I _hate_ this.
-def fixu8(s):
-	"""Calls _fixu8(), which does the real work, line by line. Otherwise
-	we choose the wrong encoding for big buffers and end up messing
-	output."""
-	n = []
-	for i in s.split('\n'):
-		n.append(_fixu8(i))
-	return '\n'.join(n)
-
-def _fixu8(s):
-	if type(s) == unicode:
-		return s.encode('utf8', 'replace')
-	for e in config.repoencoding:
-		try:
-			return s.decode(e).encode('utf8', 'replace')
-		except UnicodeDecodeError:
-			pass
-	raise UnicodeDecodeError, config.repoencoding
-
-
-def escape(s):
-	s = xml_escape(s)
-	s = s.replace('"', '&quot;')
-	return s
+def urlescape(s):
+    """Escape string for use inside URLs/links."""
+    # Using errors=surrogateescape makes invalid UTF8 translate well through
+    # the URL. We have to also use it in the cgi.FieldStorage so the
+    # unescaping works.
+    return urllib.parse.quote(s, errors="surrogateescape")
+
 
 def how_old(epoch):
-	if config.cachedir:
-		# when we have a cache, the how_old() becomes a problem since
-		# the cached entries will have old data; so in this case just
-		# return a nice string
-		t = time.localtime(epoch)
-		currentYear = time.localtime()[0]
-		if t[0] == currentYear:
-			s = time.strftime("%d %b %H:%M", t)
-		else:
-			s = time.strftime("%d %b %Y %H:%M", t)
-		return s
-	age = int(time.time()) - int(epoch)
-	if age > 60*60*24*365*2:
-		s = str(age/60/60/24/365)
-		s += " years ago"
-	elif age > 60*60*24*(365/12)*2:
-		s = str(age/60/60/24/(365/12))
-		s += " months ago"
-	elif age > 60*60*24*7*2:
-		s = str(age/60/60/24/7)
-		s += " weeks ago"
-	elif age > 60*60*24*2:
-		s = str(age/60/60/24)
-		s += " days ago"
-	elif age > 60*60*2:
-		s = str(age/60/60)
-		s += " hours ago"
-	elif age > 60*2:
-		s = str(age/60)
-		s += " minutes ago"
-	elif age > 2:
-		s = str(age)
-		s += " seconds ago"
-	else:
-		s = "right now"
-	return s
-
-def shorten_str(s, max = 60):
-	if len(s) > max:
-		s = s[:max - 4] + ' ...'
-	return s
+    if config.cachedir:
+        # when we have a cache, the how_old() becomes a problem since
+        # the cached entries will have old data; so in this case just
+        # return a nice string
+        t = time.localtime(epoch)
+        currentYear = time.localtime()[0]
+        if t[0] == currentYear:
+            s = time.strftime("%d %b %H:%M", t)
+        else:
+            s = time.strftime("%d %b %Y %H:%M", t)
+        return s
+    age = int(time.time()) - int(epoch)
+    if age > 60 * 60 * 24 * 365 * 2:
+        s = str(int(age / 60 / 60 / 24 / 365))
+        s += " years ago"
+    elif age > 60 * 60 * 24 * (365 / 12) * 2:
+        s = str(int(age / 60 / 60 / 24 / (365 / 12)))
+        s += " months ago"
+    elif age > 60 * 60 * 24 * 7 * 2:
+        s = str(int(age / 60 / 60 / 24 / 7))
+        s += " weeks ago"
+    elif age > 60 * 60 * 24 * 2:
+        s = str(int(age / 60 / 60 / 24))
+        s += " days ago"
+    elif age > 60 * 60 * 2:
+        s = str(int(age / 60 / 60))
+        s += " hours ago"
+    elif age > 60 * 2:
+        s = str(int(age / 60))
+        s += " minutes ago"
+    elif age > 2:
+        s = str(int(age))
+        s += " seconds ago"
+    else:
+        s = "right now"
+    return s
+
+
+def shorten_str(s, max=60):
+    if len(s) > max:
+        s = s[: max - 4] + " ..."
+    return s
+
 
 def replace_tabs(s):
-	pos = s.find("\t")
-	while pos != -1:
-		count = 8 - (pos % 8)
-		if count:
-			spaces = ' ' * count
-			s = s.replace('\t', spaces, 1)
-		pos = s.find("\t")
-	return s
+    pos = s.find("\t")
+    while pos != -1:
+        count = 8 - (pos % 8)
+        if count:
+            spaces = " " * count
+            s = s.replace("\t", spaces, 1)
+        pos = s.find("\t")
+    return s
+
 
 def replace_links(s):
-	"""Replace user defined strings with links, as specified in the
-	configuration file."""
-	import re
-
-	vardict = {
-		"myreponame": config.myreponame,
-		"reponame": config.reponame,
-	}
+    """Replace user defined strings with links, as specified in the
+    configuration file."""
+
+    vardict = {
+        "myreponame": config.myreponame,
+        "reponame": config.reponame,
+    }
 
-	for link_pat, link_dst in config.url_links:
-		s = re.sub(link_pat, link_dst % vardict, s)
+    for link_pat, link_dst in config.url_links:
+        s = re.sub(link_pat, link_dst % vardict, s)
+
+    return s
 
-	return s
 
 def strip_ignore_this(s):
-	"""Strip out darcs' Ignore-this: metadata if present."""
-	import re
-	return re.sub(r'^Ignore-this:[^\n]*\n?','',s)
+    """Strip out darcs' Ignore-this: metadata if present."""
+    return re.sub(r"^Ignore-this:[^\n]*\n?", "", s)
+
 
 def highlight(s, l):
-	"Highlights appearences of s in l"
-	import re
-	# build the regexp by leaving "(s)", replacing '(' and ') first
-	s = s.replace('\\', '\\\\')
-	s = s.replace('(', '\\(')
-	s = s.replace(')', '\\)')
-	s = '(' + escape(s) + ')'
-	try:
-		pat = re.compile(s, re.I)
-		repl = '<span style="color:#e00000">\\1</span>'
-		l = re.sub(pat, repl, l)
-	except:
-		pass
-	return l
+    "Highlights appearences of s in l"
+    # build the regexp by leaving "(s)", replacing '(' and ') first
+    s = s.replace("\\", "\\\\")
+    s = s.replace("(", "\\(")
+    s = s.replace(")", "\\)")
+    s = "(" + xmlescape(s) + ")"
+    try:
+        pat = re.compile(s, re.I)
+        repl = '<span style="color:#e00000">\\1</span>'
+        l = re.sub(pat, repl, l)
+    except:
+        pass
+    return l
+
 
 def fperms(fname):
-	m = os.stat(fname)[stat.ST_MODE]
-	m = m & 0777
-	s = []
-	if os.path.isdir(fname): s.append('d')
-	else: s.append('-')
-
-	if m & 0400: s.append('r')
-	else: s.append('-')
-	if m & 0200: s.append('w')
-	else: s.append('-')
-	if m & 0100: s.append('x')
-	else: s.append('-')
-
-	if m & 0040: s.append('r')
-	else: s.append('-')
-	if m & 0020: s.append('w')
-	else: s.append('-')
-	if m & 0010: s.append('x')
-	else: s.append('-')
-
-	if m & 0004: s.append('r')
-	else: s.append('-')
-	if m & 0002: s.append('w')
-	else: s.append('-')
-	if m & 0001: s.append('x')
-	else: s.append('-')
+    m = os.stat(fname)[stat.ST_MODE]
+    m = m & 0o777
+    s = []
+    if os.path.isdir(fname):
+        s.append("d")
+    else:
+        s.append("-")
+
+    if m & 0o400:
+        s.append("r")
+    else:
+        s.append("-")
+    if m & 0o200:
+        s.append("w")
+    else:
+        s.append("-")
+    if m & 0o100:
+        s.append("x")
+    else:
+        s.append("-")
+
+    if m & 0o040:
+        s.append("r")
+    else:
+        s.append("-")
+    if m & 0o020:
+        s.append("w")
+    else:
+        s.append("-")
+    if m & 0o010:
+        s.append("x")
+    else:
+        s.append("-")
+
+    if m & 0o004:
+        s.append("r")
+    else:
+        s.append("-")
+    if m & 0o002:
+        s.append("w")
+    else:
+        s.append("-")
+    if m & 0o001:
+        s.append("x")
+    else:
+        s.append("-")
+
+    return "".join(s)
 
-	return ''.join(s)
 
 def fsize(fname):
-	s = os.stat(fname)[stat.ST_SIZE]
-	if s < 1024:
-		return "%s" % s
-	elif s < 1048576:
-		return "%sK" % (s / 1024)
-	elif s < 1073741824:
-		return "%sM" % (s / 1048576)
+    s = os.stat(fname)[stat.ST_SIZE]
+    if s < 1024:
+        return "%s" % s
+    elif s < 1048576:
+        return "%sK" % int(s / 1024)
+    elif s < 1073741824:
+        return "%sM" % int(s / 1048576)
+
 
 def isbinary(fname):
-	import re
-	bins = open(config.repodir + '/_darcs/prefs/binaries').readlines()
-	bins = [b[:-1] for b in bins if b and b[0] != '#']
-	for b in bins:
-		if re.compile(b).search(fname):
-			return 1
-	return 0
+    bins = open(config.repodir + "/_darcs/prefs/binaries").readlines()
+    bins = [b[:-1] for b in bins if b and b[0] != "#"]
+    for b in bins:
+        if re.compile(b).search(fname):
+            return 1
+    return 0
+
 
 def realpath(fname):
-	realf = filter_file(config.repodir + '/_darcs/pristine/' + fname)
-	if os.path.exists(realf):
-		return realf
-	realf = filter_file(config.repodir + '/_darcs/current/' + fname)
-	if os.path.exists(realf):
-		return realf
-	realf = filter_file(config.repodir + '/' + fname)
-	return realf
-
-def log_times(cache_hit, repo = None, event = None):
-	if not config.logtimes:
-		return
-
-	time_total = time.time() - time_begin
-	processing = time_total - time_imports
-	if not event:
-		event = action
-	if cache_hit:
-		event = event + " (hit)"
-	s = '%s\n' % event
+    realf = filter_file(config.repodir + "/" + fname)
+    return realf
+
 
-	if repo:
-		s += '\trepo: %s\n' % repo
+def log_times(cache_hit, repo=None, event=None):
+    if not config.logtimes:
+        return
+
+    time_total = time.time() - time_begin
+    processing = time_total - time_imports
+    if not event:
+        event = action
+    if cache_hit:
+        event = event + " (hit)"
+    s = "%s\n" % event
 
-	s += """\
+    if repo:
+        s += "\trepo: %s\n" % repo
+
+    s += """\
 	total: %.3f
 	processing: %.3f
-	imports: %.3f\n""" % (time_total, processing, time_imports)
-
-	if darcs_runs:
-		s += "\truns:\n"
-		for params in darcs_runs:
-			s += '\t\t%s\n' % ' '.join(params)
-	s += '\n'
-
-	lf = open(config.logtimes, 'a')
-	lf.write(s)
-	lf.close()
+	imports: %.3f\n""" % (
+        time_total,
+        processing,
+        time_imports,
+    )
+
+    if darcs_runs:
+        s += "\truns:\n"
+        for params in darcs_runs:
+            s += "\t\t%s\n" % " ".join(params)
+    s += "\n"
+
+    lf = open(config.logtimes, "a", errors="surrogateescape")
+    lf.write(s)
+    lf.close()
 
 
 def parse_darcs_time(s):
-	"Try to convert a darcs' time string into a Python time tuple."
-	try:
-		return time.strptime(s, "%Y%m%d%H%M%S")
-	except ValueError:
-		# very old darcs commits use a different format, for example:
-		# "Wed May 21 19:39:10 CEST 2003" or even:
-		# "Sun Sep 21 07:23:57 Pacific Daylight Time 2003"
-		# we can't parse the time zone part reliably, so we ignore it
-		fmt = "%a %b %d %H:%M:%S %Y"
-		parts = s.split()
-		ns = ' '.join(parts[0:4]) + ' ' + parts[-1]
-		return time.strptime(ns, fmt)
-
+    "Try to convert a darcs' time string into a Python time tuple."
+    try:
+        return time.strptime(s, "%Y%m%d%H%M%S")
+    except ValueError:
+        # very old darcs commits use a different format, for example:
+        # "Wed May 21 19:39:10 CEST 2003" or even:
+        # "Sun Sep 21 07:23:57 Pacific Daylight Time 2003"
+        # we can't parse the time zone part reliably, so we ignore it
+        fmt = "%a %b %d %H:%M:%S %Y"
+        parts = s.split()
+        ns = " ".join(parts[0:4]) + " " + parts[-1]
+        return time.strptime(ns, fmt)
 
 
 #
 # generic html functions
 #
 
+
 def print_header():
-	print "Content-type: text/html; charset=utf-8"
-	print """
+    print("Content-type: text/html; charset=utf-8")
+    print(
+        """
 <?xml version="1.0" encoding="utf-8"?>
 <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
 		"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
 <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en-US" lang="en-US">
-<!-- darcsweb 1.2
+<!-- darcsweb 1.3
      Alberto Bertogli (albertito@blitiri.com.ar).
 
      Based on gitweb, which is written by Kay Sievers <kay.sievers@vrfy.org>
